!Examples of LIST Sorting using SortHeaderClassType in BrwExt.INC by Carl Barnes for CIDC 2019.
!There is a lot code in that Class. Here I have done the minimum to get it to work.
!You will need to explore the BrwExt.CLW Class code in LibSrc to learn more.
!These is also a template BrwExt.TPW that may provide more insight ... NOT that I see.

  PROGRAM
  INCLUDE 'KEYCODES.CLW'
  INCLUDE('BrwExt.INC'),ONCE
  MAP
BrwExtCLW_SortHeaderClass  PROCEDURE()  
BrwExtCLW_SortHeaderClass_ColumnReorder    PROCEDURE()  !Columns NOT in Queue Order
    MODULE('Win32')
        GetTempPath(LONG nBufferLength,*CSTRING lpTempPath),LONG,PASCAL,DLL(1),RAW,NAME('GetTempPathA'),PROC
    END          
  END
WinTempBS  CSTRING(256)
  CODE       
  IF ~GetTempPath(SIZE(WinTempBS),WinTempBS) THEN Message('Failed GetTempPath').
  SYSTEM{PROP:PropVScroll}=1
  IF START(BrwExtCLW_SortHeaderClass_ColumnReorder).
  IF START(BrwExtCLW_SortHeaderClass).

!================================================================================
BrwExtCLW_SortHeaderClass    PROCEDURE()
QNdx    LONG,AUTO
DirQ    QUEUE(FILE:Queue),PRE(DirQ)
        END ! DirQ:Name  DirQ:ShortName(8.3?)  DirQ:Date  DirQ:Time  DirQ:Size  DirQ:Attrib
FilesWindow WINDOW('BrwExt.CLW SortHeaderClassType'),AT(1,1,343,180),FONT('Segoe UI',9,,FONT:regular),SYSTEM,GRAY,RESIZE
              STRING('Column Sorting done with BrwExt.CLW SortHeaderClassType'),AT(2,2),USE(?HowSort)
              STRING('Ctrl+Click Header adds a Sort Column. Shift+Click does ... something ... look at BrwExtCLW'),AT(2,12),USE(?HowSort2)
              LIST,AT(1,25),USE(?ListFiles),FULL,VSCROLL,TIP('Click heads to sort, Click again to reverse'), |
                FORMAT('120L(1)|M~Name~@s255@52L(1)|M~Short Name~@s13@40R(1)|M~Date~C(0)@d1@40R(1)|M~Time~C(0)@T4@56R(1)|M~Size~C(0)@n13@16L(1)|M~Attr~@n3@') ,|
                FROM(DirQ)
            END
SortCls     SortHeaderClassType            
    CODE
    FREE(DirQ)
    DIRECTORY(DirQ,WinTempBS&'*.*',ff_:NORMAL)
    LOOP QNdx = RECORDS(DirQ) TO 1 BY -1 !--Keep directories, Delete files, Case Name
         GET(DirQ,QNdx)
         IF BAND(DirQ:Attrib,FF_:Directory) OR DirQ:Name='.' OR DirQ:Name='..'   !. or .. Dirs
            DELETE(DirQ)
         ELSE
             DirQ:Name=UPPER(DirQ:Name[1]) & DirQ:Name[2 : SIZE(DirQ:Name) ]
             PUT(DirQ)
         END
    END
    OPEN(FilesWindow)
    0{PROP:Text}=CLIP(0{PROP:Text}) &'  '& WinTempBS & ' (' & RECORDS(DirQ) &' records) '
    ACCEPT
       CASE EVENT()
       OF EVENT:OpenWindow 
          SortCls.Init(DirQ,?ListFiles)
          SortCls.SetSortOrder(1)
       END
       CASE FIELD()
       OF ?ListFiles 
          SortCls.TakeEvents()
       END ! Case FIELD()
    END !ACCEPT
    CLOSE(FilesWindow)

!==========================================================================================
!This has the File Name last in the LIST using Format #1#. The Class handles it.
BrwExtCLW_SortHeaderClass_ColumnReorder    PROCEDURE()
QNdx    LONG,AUTO
DirQ    QUEUE(FILE:Queue),PRE(DirQ)
        END ! DirQ:Name  DirQ:ShortName(8.3?)  DirQ:Date  DirQ:Time  DirQ:Size  DirQ:Attrib
FilesWindow WINDOW('#1# Columns not in Queue Order - BrwExt.CLW SortHeaderClassType '),AT(345,1,343,250),GRAY,SYSTEM,FONT('Segoe UI',9,, |
            FONT:regular),RESIZE
                      STRING('Column 5 Name is Q Field #1#. Column Sorting done with BrwExt.CLW SortHeaderClassType'),AT(2,2),USE(?HowSort)
        LIST,AT(1,15),FULL,USE(?ListFiles),VSCROLL,TIP('Click heads to sort, Click again to reverse'), |
                FROM(DirQ),FORMAT('52L(1)|M~Short Name~@s13@#2#40R(1)|M~Date~C(0)@' & |
                'd1@40R(1)|M~Time~C(0)@T4@56R(1)|M~Size~C(0)@n13@120L(1)|M~Name~@s255@#1#')
    END
SortCls     SortHeaderClassType 
    CODE
    FREE(DirQ)
    DIRECTORY(DirQ,WinTempBS&'*.*',ff_:NORMAL)  
    LOOP QNdx = RECORDS(DirQ) TO 1 BY -1        !--Keep directories, Delete files, Case Name
         GET(DirQ,QNdx)
         IF BAND(DirQ:Attrib,FF_:Directory) OR DirQ:Name='.' OR DirQ:Name='..'   !. or .. Dirs
            DELETE(DirQ)
         ELSE
            DirQ:Name=UPPER(DirQ:Name[1]) & DirQ:Name[2 : SIZE(DirQ:Name) ]
            PUT(DirQ)
         END
    END 
    OPEN(FilesWindow) 
    0{PROP:Text}=CLIP(0{PROP:Text}) &'  '& WinTempBS & ' (' & RECORDS(DirQ) &' records) '
    ACCEPT
       CASE EVENT()
       OF EVENT:OpenWindow 
          SortCls.Init(DirQ,?ListFiles)
          SortCls.SetSortOrder(5)
       END
       CASE FIELD()
       OF ?ListFiles 
          SortCls.TakeEvents()
       END ! Case FIELD()    
    END !ACCEPT
    CLOSE(FilesWindow)

    